Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/NikonCustom.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/NikonCustom.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/NikonCustom.pm	(revision 34921)
@@ -3673,14 +8556,960 @@
         Mask => 0xe0,
         PrintConv => {
-            0x00 => '4 s',
-            0x20 => '10 s', # default
-            0x40 => '20 s',
-            0x60 => '1 min',
-            0x80 => '5 min',
-            0xa0 => '10 min',
+            0 => '4 s',
+            1 => '10 s', # default
+            2 => '20 s',
+            3 => '1 min',
+            4 => '5 min',
+            5 => '10 min',
         },
     },
 );
 
+# D4/D4S custom settings (ref 1, decoded from D4S)
+%Image::ExifTool::NikonCustom::SettingsD4 = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
+    WRITABLE => 1,
+    FIRST_ENTRY => 0,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'Custom settings for the D4 and D4S.',
+    0.1 => {
+        Name => 'CustomSettingsBank',
+        Mask => 0x03,
+        PrintConv => {
+            0 => 'A',
+            1 => 'B',
+            2 => 'C',
+            3 => 'D',
+        },
+    },
+    1.1 => { #CSa1
+        Name => 'AF-CPrioritySelection',
+        Mask => 0xc0,
+        PrintConv => {
+            0 => 'Release',
+            1 => 'Release + Focus',
+            2 => 'Focus',
+            3 => 'Focus + Release',
+        },
+    },
+    1.2 => { # CSa2
+        Name => 'AF-SPrioritySelection',
+        Mask => 0x20,
+        PrintConv => {
+            0 => 'Focus',
+            1 => 'Release',
+        },
+    },
+    1.3 => { # CSa7
+        Name => 'AFPointSelection',
+        Mask => 0x10,
+        PrintConv => {
+            0 => '51 Points',
+            1 => '11 Points',
+        },
+    },
+    1.4 => { # CSa3
+        Name => 'FocusTrackingLockOn',
+        Mask => 0x07,
+        PrintConv => {
+            0 => 'Off',
+            1 => '1 (Short)',
+            2 => '2',
+            3 => '3 (Normal)',
+            4 => '4',
+            5 => '5 (Long)',
+        },
+    },
+    2.1 => { # CSa4
+        Name => 'AFActivation',
+        Mask => 0x80,
+        PrintConv => {
+            0 => 'Shutter/AF-On',
+            1 => 'AF-On Only',
+        },
+    },
+    2.2 => { # CSa6
+        Name => 'FocusPointWrap',
+        Mask => 0x08,
+        PrintConv => {
+            0 => 'No Wrap',
+            1 => 'Wrap',
+        },
+    },
+    4.1 => { # CSd1-b
+        Name => 'Pitch',
+        Mask => 0x40,
+        PrintConv => { 0 => 'High', 1 => 'Low' },
+    },
+    4.2 => { # CSf12
+        Name => 'NoMemoryCard',
+        Mask => 0x20,
+        PrintConv => {
+            0 => 'Release Locked',
+            1 => 'Enable Release',
+        },
+    },
+    4.3 => { # CSd6
+        Name => 'GridDisplay',
+        Mask => 0x02,
+        PrintConv => \%onOff,
+    },
+    5.1 => { # CSd9
+        Name => 'ShootingInfoDisplay',
+        Mask => 0xc0,
+        PrintConv => {
+            # 0 - seen for D4 (PH)
+            1 => 'Auto',
+            2 => 'Manual (dark on light)',
+            3 => 'Manual (light on dark)',
+        },
+    },
+    5.2 => { # CSd10
+        Name => 'LCDIllumination',
+        Mask => 0x20,
+        PrintConv => \%offOn,
+    },
+    5.3 => { # CSd8
+        Name => 'ScreenTips',
+        Mask => 0x04,
+        PrintConv => \%offOn,
+    },
+    5.4 => { # CSd1-a
+        Name => 'Beep',
+        Mask => 0x03,
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Low',
+            2 => 'Medium',
+            3 => 'High',
+        },
+    },
+    6.1 => { # CSf13
+        Name => 'ReverseIndicators',
+        Mask => 0x80,
+        PrintConv => {
+            0 => '+ 0 -',
+            1 => '- 0 +',
+        },
+    },
+    6.2 => { # CSd7-a
+        Name => 'RearDisplay',
+        Mask => 0x40,
+        PrintConv => {
+            0 => 'ISO',
+            1 => 'Exposures Remaining',
+        },
+    },
+    6.3 => { # CSd7-b
+        Name => 'ViewfinderDisplay',
+        Mask => 0x20,
+        PrintConv => {
+            0 => 'Frame Count',
+            1 => 'Exposures Remaining',
+        },
+    },
+    6.4 => { # CSd10-a
+        Name => 'CommandDialsReverseRotation',
+        Mask => 0x18,
+        PrintConv => {
+            0 => 'No',
+            1 => 'Shutter Speed & Aperture',
+            2 => 'Exposure Compensation',
+            3 => 'Exposure Compensation, Shutter Speed & Aperture',
+        },
+    },
+    6.5 => { # CSb4
+        Name => 'EasyExposureCompensation',
+        Mask => 0x03,
+        PrintConv => {
+            0 => 'Off',
+            1 => 'On',
+            2 => 'On (auto reset)',
+        },
+    },
+    7.1 => { # CSb2
+        Name => 'ExposureControlStepSize',
+        Mask => 0xc0,
+        PrintConv => {
+            0 => '1/3 EV',
+            1 => '1/2 EV',
+            2 => '1 EV',
+        },
+    },
+    7.2 => { # CSb1
+        Name => 'ISOStepSize',
+        Mask => 0x30,
+        PrintConv => {
+            0 => '1/3 EV',
+            1 => '1/2 EV',
+            2 => '1 EV',
+        },
+    },
+    7.3 => { # CSb3
+        Name => 'ExposureCompStepSize',
+        Mask => 0x0c,
+        PrintConv => {
+            0 => '1/3 EV',
+            1 => '1/2 EV',
+            2 => '1 EV',
+        },
+    },
+    8.1 => { # CSb6 (CSb5 for D4)
+        Name => 'CenterWeightedAreaSize',
+        Mask => 0xe0,
+        PrintConv => {
+            0 => '8 mm',
+            1 => '12 mm',
+            2 => '15 mm',
+            3 => '20 mm',
+            4 => 'Average',
+        },
+    },
+    8.2 => { # CSb7-a
+        Name => 'FineTuneOptMatrixMetering',
+        Mask => 0x0f,
+        ValueConv => '($val > 0x7 ? $val - 0x10 : $val) / 6',
+        ValueConvInv => 'int($val*6+($val>0?0.5:-0.5))',
+        PrintConv => '$val ? sprintf("%+.2f", $val) : 0',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    9.1 => { # CSb7-b
+        Name => 'FineTuneOptCenterWeighted',
+        Mask => 0xf0,
+        ValueConv => '($val > 0x7 ? $val - 0x10 : $val) / 6',
+        ValueConvInv => 'int($val*6+($val>0?0.5:-0.5))',
+        PrintConv => '$val ? sprintf("%+.2f", $val) : 0',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    9.2 => { # CSb7-c
+        Name => 'FineTuneOptSpotMetering',
+        Mask => 0x0f,
+        ValueConv => '($val > 0x7 ? $val - 0x10 : $val) / 6',
+        ValueConvInv => 'int($val*6+($val>0?0.5:-0.5))',
+        PrintConv => '$val ? sprintf("%+.2f", $val) : 0',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    10.1 => { # CSf1-a
+        Name => 'MultiSelectorShootMode',
+        Mask => 0xc0,
+        PrintConv => {
+            0 => 'Select Center Focus Point (Reset)',
+            2 => 'Preset Focus Point (Pre)',
+            3 => 'Not Used (None)',
+        },
+    },
+    10.2 => { # CSf1-b
+        Name => 'MultiSelectorPlaybackMode',
+        Mask => 0x30,
+        PrintConv => {
+            0 => 'Thumbnail On/Off',
+            1 => 'View Histograms',
+            2 => 'Zoom On/Off',
+            3 => 'Choose Folder',
+        },
+    },
+    10.3 => { # CSf2
+        Name => 'MultiSelector',
+        Mask => 0x01,
+        PrintConv => {
+            0 => 'Do Nothing',
+            1 => 'Reset Meter-off Delay',
+        },
+    },
+    11.1 => { # CSd4
+        Name => 'ExposureDelayMode',
+        Mask => 0xc0,
+        PrintConv => {
+            0 => 'Off',
+            1 => '1 s',
+            2 => '2 s',
+            3 => '3 s',
+        },
+    },
+    11.2 => { # CSd2-a
+        Name => 'CHModeShootingSpeed',
+        Mask => 0x10,
+        PrintConv => {
+            0 => '10 fps',
+            1 => '11 fps',
+        },
+    },
+    11.3 => { # CSd2-b
+        Name => 'CLModeShootingSpeed',
+        Mask => 0x0f,
+        PrintConv => '"$val fps"',
+        PrintConvInv => '$val=~s/\s*fps//i; $val',
+    },
+    12 => { # CSd3
+        Name => 'MaxContinuousRelease',
+        # values: 1-200
+    },
+    13.1 => { # CSe6
+        Name => 'AutoBracketSet',
+        Mask => 0xe0,
+        PrintConv => {
+            0 => 'AE & Flash',
+            1 => 'AE Only',
+            2 => 'Flash Only',
+            3 => 'WB Bracketing',
+            4 => 'Active D-Lighting',
+        },
+    },
+    13.2 => { # CSe8
+        Name => 'AutoBracketOrder',
+        Mask => 0x10,
+        PrintConv => {
+            0 => '0,-,+',
+            1 => '-,0,+',
+        },
+    },
+    13.3 => { # CSe7
+        Name => 'AutoBracketModeM',
+        Mask => 0x0c,
+        PrintConv => {
+            0 => 'Flash/Speed',
+            1 => 'Flash/Speed/Aperture',
+            2 => 'Flash/Aperture',
+            3 => 'Flash Only',
+        },
+    },
+    14.1 => { # CSf3-a
+        Name => 'FuncButton',
+        Mask => 0xf8,
+        PrintConv => {
+            0 => 'None',
+            1 => 'Preview',
+            2 => 'FV Lock',
+            3 => 'AE/AF Lock',
+            4 => 'AE Lock Only',
+            5 => 'AE Lock (reset on release)',
+            6 => 'AE Lock (hold)',
+            7 => 'AF Lock Only',
+            8 => 'AF-On',
+            10 => 'Bracketing Burst',
+            11 => 'Matrix Metering',
+            12 => 'Center-weighted Metering',
+            13 => 'Spot Metering',
+            14 => 'Playback',
+            15 => 'My Menu Top Item',
+            16 => '+NEF(RAW)',
+            17 => 'Virtual Horizon',
+            18 => 'My Menu',
+            20 => 'Grid Display',
+            21 => 'Disable Synchronized Release',
+            22 => 'Remote Release Only',
+            26 => 'Flash Disable/Enable',
+        },
+    },
+    14.2 => { # CSf3-b
+        Name => 'FuncButtonPlusDials',
+        Mask => 0x07,
+        PrintConv => {
+            0 => 'None',
+            1 => 'Choose Image Area (FX/DX/5:4)',
+            2 => 'Shutter Speed & Aperture Lock',
+            3 => 'One Step Speed / Aperture',
+            4 => 'Choose Non-CPU Lens Number',
+            5 => 'Active D-Lighting',
+            6 => 'Shooting Bank Menu',
+        },
+    },
+    15.1 => { # CSf4-a
+        Name => 'PreviewButton',
+        Mask => 0xf8,
+        PrintConv => {
+            0 => 'None',
+            1 => 'Preview',
+            2 => 'FV Lock',
+            3 => 'AE/AF Lock',
+            4 => 'AE Lock Only',
+            5 => 'AE Lock (reset on release)',
+            6 => 'AE Lock (hold)',
+            7 => 'AF Lock Only',
+            8 => 'AF-On',
+            10 => 'Bracketing Burst',
+            11 => 'Matrix Metering',
+            12 => 'Center-weighted Metering',
+            13 => 'Spot Metering',
+            14 => 'Playback',
+            15 => 'My Menu Top Item',
+            16 => '+NEF(RAW)',
+            17 => 'Virtual Horizon',
+            18 => 'My Menu',
+            20 => 'Grid Display',
+            21 => 'Disable Synchronized Release',
+            22 => 'Remote Release Only',
+            26 => 'Flash Disable/Enable',
+        },
+    },
+    15.2 => { # CSf4-b
+        Name => 'PreviewButtonPlusDials',
+        Mask => 0x07,
+        PrintConv => {
+            0 => 'None',
+            1 => 'Choose Image Area (FX/DX/5:4)',
+            2 => 'Shutter Speed & Aperture Lock',
+            3 => 'One Step Speed / Aperture',
+            4 => 'Choose Non-CPU Lens Number',
+            5 => 'Active D-Lighting',
+            6 => 'Shooting Bank Menu',
+        },
+    },
+    16.1 => { # CSf9
+        Name => 'AssignBktButton',
+        Mask => 0x07,
+        PrintConv => {
+            0 => 'Auto Bracketing',
+            1 => 'Multiple Exposure',
+            2 => 'HDR (high dynamic range)',
+            3 => 'None',
+        },
+    },
+    18.1 => { # CSf10-b
+        Name => 'CommandDialsChangeMainSub',
+        Mask => 0xe0,
+        PrintConv => {
+            0 => 'Autofocus Off, Exposure Off',
+            1 => 'Autofocus Off, Exposure On',
+            2 => 'Autofocus Off, Exposure On (Mode A)',
+            4 => 'Autofocus On, Exposure Off',
+            5 => 'Autofocus On, Exposure On',
+            6 => 'Autofocus On, Exposure On (Mode A)',
+        },
+    },
+    18.2 => { # CSf10-d
+        Name => 'CommandDialsMenuAndPlayback',
+        Mask => 0x18,
+        PrintConv => {
+            0 => 'On',
+            1 => 'Off',
+            2 => 'On (Image Review Excluded)',
+        },
+    },
+    18.3 => { # CSf10-c
+        Name => 'CommandDialsApertureSetting',
+        Mask => 0x04,
+        PrintConv => {
+            0 => 'Sub-command Dial',
+            1 => 'Aperture Ring',
+        },
+    },
+    18.4 => { # CSc1
+        Name => 'ShutterReleaseButtonAE-L',
+        Mask => 0x02,
+        PrintConv => \%offOn,
+    },
+    18.5 => { # CSf11
+        Name => 'ReleaseButtonToUseDial',
+        Mask => 0x01,
+        PrintConv => \%noYes,
+    },
+    19.1 => { # CSc2
+        Name => 'StandbyTimer',
+        Mask => 0xf0,
+        PrintConv => {
+            0 => '4 s',
+            1 => '6 s',
+            3 => '10 s',
+            5 => '30 s',
+            6 => '1 min',
+            7 => '5 min',
+            8 => '10 min',
+            9 => '30 min',
+        },
+    },
+    20.1 => { # CSc3-a
+        Name => 'SelfTimerTime',
+        Mask => 0xc0,
+        PrintConv => {
+            0 => '2 s',
+            1 => '5 s',
+            2 => '10 s',
+            3 => '20 s',
+        },
+    },
+    20.2 => { # CSc3-b
+        Name => 'SelfTimerShotCount',
+        Mask => 0x0f,
+    },
+    20.3 => { # CSc3-c
+        Name => 'SelfTimerShotInterval',
+        Mask => 0x30,
+        PrintConv => {
+            0 => '0.5 s',
+            1 => '1 s',
+            2 => '2 s',
+            3 => '3 s',
+        },
+    },
+    21.1 => { # CSc4-d
+        Name => 'ImageReviewMonitorOffTime',
+        Mask => 0xe0,
+        PrintConv => {
+            0 => '2 s',
+            1 => '4 s',
+            2 => '10 s',
+            3 => '20 s',
+            4 => '1 min',
+            5 => '5 min',
+            6 => '10 min',
+
+        },
+    },
+    21.2 => { # CSc4-e
+        Name => 'LiveViewMonitorOffTime',
+        Mask => 0x1c,
+        PrintConv => {
+            0 => '5 min',
+            1 => '10 min',
+            2 => '15 min',
+            3 => '20 min',
+            4 => '30 min',
+            5 => 'No Limit',
+        },
+    },
+    22.1 => { # CSc4-b
+        Name => 'MenuMonitorOffTime',
+        Mask => 0xe0,
+        PrintConv => {
+            0 => '4 s',
+            1 => '10 s',
+            2 => '20 s',
+            3 => '1 min',
+            4 => '5 min',
+            5 => '10 min',
+        },
+    },
+    22.2 => { # CSc4-c
+        Name => 'ShootingInfoMonitorOffTime',
+        Mask => 0x1c,
+        PrintConv => {
+            0 => '4 s',
+            1 => '10 s',
+            2 => '20 s',
+            3 => '1 min',
+            4 => '5 min',
+            5 => '10 min',
+        },
+    },
+    23.1 => { # CSe1
+        Name => 'FlashSyncSpeed',
+        Mask => 0xf0,
+        PrintConv => {
+            # 0x00 - seen for D4 (PH)
+            1 => '1/250 s (auto FP)',
+            2 => '1/250 s',
+            3 => '1/200 s',
+            4 => '1/160 s',
+            5 => '1/125 s',
+            6 => '1/100 s',
+            7 => '1/80 s',
+            8 => '1/60 s',
+        },
+    },
+    23.2 => { # CSe2
+        Name => 'FlashShutterSpeed',
+        Mask => 0x0f,
+        PrintConvColumns => 2,
+        PrintConv => {
+            0 => '1/60 s',
+            1 => '1/30 s',
+            2 => '1/15 s',
+            3 => '1/8 s',
+            4 => '1/4 s',
+            5 => '1/2 s',
+            6 => '1 s',
+            7 => '2 s',
+            8 => '4 s',
+            9 => '8 s',
+            10 => '15 s',
+            11 => '30 s',
+        },
+    },
+    31.1 => { # CSe5
+        Name => 'ModelingFlash',
+        Mask => 0x20,
+        PrintConv => \%onOff,
+    },
+    36.1 => { # CSc4-a
+        Name => 'PlaybackMonitorOffTime',
+        Mask => 0xe0,
+        PrintConv => {
+            0 => '4 s',
+            1 => '10 s',
+            2 => '20 s',
+            3 => '1 min',
+            4 => '5 min',
+            5 => '10 min',
+        },
+    },
+    37.1 => { # CSf15
+        Name => 'PlaybackZoom',
+        Mask => 0x01,
+        PrintConv => {
+            0 => 'Use Separate Zoom Buttons',
+            1 => 'Use Either Zoom Button with Command Dial',
+        },
+    },
+    38.1 => { # CSf8-a
+        Name => 'ShutterSpeedLock',
+        Mask => 0x80,
+        PrintConv => \%offOn,
+    },
+    38.2 => { # CSf8-b
+        Name => 'ApertureLock',
+        Mask => 0x40,
+        PrintConv => \%offOn,
+    },
+    38.3 => { # CSg4
+        Name => 'MovieShutterButton',
+        Mask => 0x30,
+        PrintConv => {
+            0 => 'Take Photo',
+            1 => 'Record Movies',
+            2 => 'Live Frame Grab',
+        },
+    },
+    38.4 => { # CSe4
+        Name => 'FlashExposureCompArea',
+        Mask => 0x04,
+        PrintConv => {
+            0 => 'Entire frame',
+            1 => 'Background only',
+        },
+    },
+    41.1 => { # CSg1-a
+        Name => 'MovieFunctionButton',
+        Mask => 0x70,
+        PrintConv => {
+            0 => 'None',
+            1 => 'Power Aperture (open)', # bit '02' is also toggled on for this setting
+            3 => 'Index Marking',
+            4 => 'View Photo Shooting Info',
+        },
+    },
+    41.2 => { # CSg2-a
+        Name => 'MoviePreviewButton',
+        Mask => 0x07,
+        PrintConv => {
+            0 => 'None',
+            2 => 'Power Aperture (open)', # bit '10' is also toggled on for this setting
+            3 => 'Index Marking',
+            4 => 'View Photo Shooting Info',
+        },
+    },
+    42.1 => { # CSf14
+        Name => 'VerticalMultiSelector',
+        Mask => 0x60,
+        PrintConv => {
+            0 => 'Same as Multi-Selector with Info(U/D) & Playback(R/L)',
+            1 => 'Same as Multi-Selector with Info(R/L) & Playback(U/D)',
+            2 => 'Focus Point Selection',
+        },
+    },
+    42.2 => { # CSf7-a
+        Name => 'VerticalFuncButton',
+        Mask => 0x1f,
+        PrintConv => {
+            0 => 'None',
+            1 => 'Preview',
+            2 => 'FV Lock',
+            3 => 'AE/AF Lock',
+            4 => 'AE Lock Only',
+            5 => 'AE Lock (reset on release)',
+            6 => 'AE Lock (hold)',
+            7 => 'AF Lock Only',
+            10 => 'Bracketing Burst',
+            11 => 'Matrix Metering',
+            12 => 'Center-weighted Metering',
+            13 => 'Spot Metering',
+            14 => 'Playback',
+            15 => 'My Menu Top Item',
+            16 => '+NEF(RAW)',
+            17 => 'Virtual Horizon',
+            18 => 'My Menu',
+            20 => 'Grid Display',
+            26 => 'Flash Disable/Enable',
+        },
+    },
+    43.1 => { # CSf7-b
+        Name => 'VerticalFuncButtonPlusDials',
+        Mask => 0xf0,
+        PrintConv => {
+            0 => 'None',
+            1 => 'Choose Image Area (FX/DX/5:4)',
+            2 => 'Shutter Speed & Aperture Lock',
+            3 => 'One Step Speed / Aperture',
+            4 => 'Choose Non-CPU Lens Number',
+            5 => 'Active D-Lighting',
+            6 => 'Shooting Bank Menu',
+            7 => 'ISO Sensitivity',
+            8 => 'Exposure Mode',
+            9 => 'Exposure Compensation',
+            10 => 'Metering',
+        },
+    },
+    43.2 => { # CSf16
+        Name => 'AssignMovieRecordButton',
+        Mask => 0x07,
+        PrintConv => {
+            0 => 'None',
+            1 => 'Choose Image Area (FX/DX/5:4)',
+            2 => 'Shutter Speed & Aperture Lock',
+            3 => 'ISO Sensitivity',
+            4 => 'Shooting Bank Menu',
+        },
+    },
+    46.1 => { # CSa5-c
+        Name => 'DynamicAreaAFDisplay',
+        Mask => 0x80,
+        PrintConv => \%offOn,
+    },
+    46.2 => { # CSa5-a
+        Name => 'AFPointIllumination',
+        Mask => 0x60,
+        PrintConv => {
+            0 => 'Off',
+            1 => 'On in Continuous Shooting Modes',
+            2 => 'On During Manual Focusing',
+            3 => 'On in Continuous Shooting and Manual Focusing',
+        },
+    },
+    46.3 => { # CSa10 (D4 is slightly different -- needs checking)
+        Name => 'StoreByOrientation',
+        Mask => 0x18,
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Focus Point',
+            2 => 'Focus Point and AF-area mode',
+        },
+    },
+    46.4 => { # CSa5-d
+        Name => 'GroupAreaAFIllumination',
+        Mask => 0x04,
+        PrintConv => {
+            0 => 'Squares',
+            1 => 'Dots',
+        },
+    },
+    46.5 => { # CSa5-b
+        Name => 'AFPointBrightness',
+        Mask => 0x03,
+        PrintConv => {
+            0 => 'Low',
+            1 => 'Normal',
+            2 => 'High',
+            3 => 'Extra High',
+        },
+    },
+    47.1 => { # CSa8
+        Name => 'AFOnButton',
+        Mask => 0x70,
+        PrintConv => {
+            0 => 'AF On',
+            1 => 'AE/AF Lock',
+            2 => 'AE Lock Only',
+            3 => 'AE Lock (reset on release)',
+            4 => 'AE Lock (hold)',
+            5 => 'AF Lock Only',
+            6 => 'None',
+        },
+    },
+    47.2 => { # CSa9
+        Name => 'VerticalAFOnButton',
+        Mask => 0x07,
+        PrintConv => {
+            0 => 'Same as AF On',
+            1 => 'AF On',
+            2 => 'AE/AF Lock',
+            3 => 'AE Lock Only',
+            4 => 'AE Lock (reset on release)',
+            5 => 'AE Lock (hold)',
+            6 => 'AF Lock Only',
+            7 => 'None',
+        },
+    },
+    48.1 => { # CSf5
+        Name => 'SubSelectorAssignment',
+        Mask => 0x80,
+        PrintConv => {
+            0 => 'Focus Point Selection',
+            1 => 'Same As Multi-selector',
+        },
+    },
+    48.2 => { # CSg3-a
+        Name => 'MovieSubSelectorAssignment',
+        Mask => 0x07,
+        PrintConv => {
+            0 => 'None',
+            1 => 'Index Marking',
+            2 => 'AE/AF Lock',
+            3 => 'AE Lock Only',
+            4 => 'AE Lock (hold)',
+            5 => 'AF Lock Only',
+            6 => 'View Photo Shooting Info',
+        },
+    },
+    49.1 => { # CSf6-a
+        Name => 'SubSelector',
+        Mask => 0xf8,
+        PrintConv => {
+            0 => 'None',
+            1 => 'Preview',
+            2 => 'FV Lock',
+            3 => 'AE/AF Lock',
+            4 => 'AE Lock Only',
+            5 => 'AE Lock (reset on release)',
+            6 => 'AE Lock (hold)',
+            7 => 'AF Lock Only',
+            8 => 'AF-On',
+            # 9 - seen for D4 (PH)
+            10 => 'Bracketing Burst',
+            11 => 'Matrix Metering',
+            12 => 'Center-weighted Metering',
+            13 => 'Spot Metering',
+            14 => 'Playback',
+            15 => 'My Menu Top Item',
+            16 => '+NEF(RAW)',
+            17 => 'Virtual Horizon',
+            18 => 'My Menu',
+            19 => 'Reset',    # value appears to be specific to this control at this time
+            20 => 'Grid Display',
+            21 => 'Disable Synchronized Release',
+            22 => 'Remote Release Only',
+            23 => 'Preview',  # value appears to be specific to this control at this time
+            26 => 'Flash Disable/Enable',
+        },
+    },
+    49.2 => { # CSf6-b
+        Name => 'SubSelectorPlusDials',
+        Mask => 0x07,
+        PrintConv => {
+            # (not all values from CSf3-b/CSf4-b are available for CSf6-b)
+            0 => 'None',
+            1 => 'Choose Image Area (FX/DX/5:4)',
+            2 => 'Shutter Speed & Aperture Lock',
+            # 3 => 'One Step Speed / Aperture', # (not available)
+            4 => 'Choose Non-CPU Lens Number',
+            # 5 => 'Active D-Lighting',         # (not available)
+            6 => 'Shooting Bank Menu',
+        },
+    },
+    50.1 => { # CSb5
+        Name => 'MatrixMetering',
+        Condition => '$$self{Model} =~ /\bD4S/',
+        Notes => 'D4S only',
+        Mask => 0x80,
+        PrintConv => {
+            0 => 'Face Detection On',
+            1 => 'Face Detection Off',
+        },
+    },
+    50.2 => { # CSf17
+        Name => 'LiveViewButtonOptions',
+        Condition => '$$self{Model} =~ /\bD4S/',
+        Notes => 'D4S only',
+        Mask => 0x30,
+        PrintConv => {
+            0 => 'Enable',
+            1 => 'Enable (standby time active)',
+            2 => 'Disable',
+        },
+    },
+    50.3 => { # CSa12
+        Name => 'AFModeRestrictions',
+        Condition => '$$self{Model} =~ /\bD4S/',
+        Notes => 'D4S only',
+        Mask => 0x03,
+        PrintConv => {
+            0 => 'Off',
+            1 => 'AF-C',
+            2 => 'AF-S',
+        },
+    },
+    51.1 => { # CSa11
+        Name => 'LimitAFAreaModeSelection',
+        Condition => '$$self{Model} =~ /\bD4S/',
+        Notes => 'D4S only',
+        Mask => 0x7e,
+        PrintConv => {
+            0 => 'No Restrictions',
+            BITMASK => {
+                0 => 'Auto-area',
+                1 => 'Group-area',
+                2 => '3D-tracking',
+                3 => 'Dynamic area (51 points)',
+                4 => 'Dynamic area (21 points)',
+                5 => 'Dynamic area (9 points)',
+            },
+        },
+    },
+    52.1 => { # CSg1-b
+        Name => 'MovieFunctionButtonPlusDials',
+        Mask => 0x10,
+        PrintConv => {
+            0 => 'None',
+            1 => 'Choose Image Area',
+        },
+    },
+    52.2 => { # CSg2-b
+        Name => 'MoviePreviewButtonPlusDials',
+        Mask => 0x01,
+        PrintConv => {
+            0 => 'None',
+            1 => 'Choose Image Area',
+        },
+    },
+    53.1 => { # CSg3-b
+        Name => 'MovieSubSelectorAssignmentPlusDials',
+        Mask => 0x10,
+        PrintConv => {
+            0 => 'None',
+            1 => 'Choose Image Area',
+        },
+    },
+    54.1 => { # CSf18
+        Name => 'AssignRemoteFnButton',
+        Condition => '$$self{Model} =~ /\bD4S/',
+        Notes => 'D4S only',
+        Mask => 0x1f,
+        PrintConv => {
+            0 => 'None',
+            1 => 'Preview',
+            2 => 'FV Lock',
+            3 => 'AE/AF Lock',
+            4 => 'AE Lock Only',
+            5 => 'AE Lock (reset on release)',
+            7 => 'AF Lock Only',
+            8 => 'AF-On',
+            16 => '+NEF(RAW)',
+            25 => 'Live View',
+            26 => 'Flash Disable/Enable',
+        },
+    },
+    55.1 => { # CSf19
+        Name => 'LensFocusFunctionButtons',
+        Condition => '$$self{Model} =~ /\bD4S/',
+        Notes => 'D4S only',
+        Mask => 0x3f,
+        PrintConv => {
+            3 => 'AE/AF Lock',
+            4 => 'AE Lock Only',
+            7 => 'AF Lock Only',
+            21 => 'Disable Synchronized Release',
+            22 => 'Remote Release Only',
+            24 => 'Preset focus Point',
+            26 => 'Flash Disable/Enable',
+            32 => 'AF-Area Mode:  Single-point AF',
+            33 => 'AF-Area Mode: Dynamic-area AF (9 points)',
+            34 => 'AF-Area Mode: Dynamic-area AF (21 points)',
+            35 => 'AF-Area Mode: Dynamic-area AF (51 points)',
+            36 => 'AF-Area Mode: Group-area AF',
+            37 => 'AF-Area Mode: Auto area AF',
+        },
+    },
+);
 
 1;  # end
@@ -3700,5 +9529,5 @@
 The Nikon custom functions are very specific to the camera model (and
 sometimes even change with firmware version).  The information is stored as
-unformatted binary data in the ShotInfo record of the Nikon MakerNotes. 
+unformatted binary data in the ShotInfo record of the Nikon MakerNotes.
 This module contains the definitions necessary for Image::ExifTool to decode
 this information.
@@ -3706,5 +9535,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
@@ -3715,5 +9544,6 @@
 Thanks to Jens Duttke and Warren Hatch for their help decoding the D300 and
 D3 custom settings.  And thanks to the customer service personnel at Best
-Buy for not bugging me while I play with their cameras.
+Buy for not bugging me while I spent lots of time playing with their
+cameras.
 
 =head1 SEE ALSO
